#!/usr/bin/perl

if(@ARGV!=2) {
	die "Usage: asbl.pl <input> <output>\n";
}

if(-e "asbltemp.o") {
	die "asbltemp.o exists. This script want to use and delete it. Stopped.\n";
}

$org="";
if(open(IN,"< $ARGV[0]")) {
	while($line=<IN>) {
		$line =~ s/\.org ([0-9a-zA-Z]+)/$org=$1/e;
	}
	close(IN);
}

if(system("gcc -c -o asbltemp.o \"$ARGV[0]\"")!=0) {
	exit $?;
}

if($org ne "") {
	$addr="--start-address=$org";
} else {
	$addr="";
}

if(open(IN,"objdump -s $addr asbltemp.o |")) {
	$content="";
	while($line=<IN>) {
		$line =~ s/^ [0-9a-zA-Z]+ (([0-9a-zA-Z]+ )+)/$content.=$1/e;
	}
	close(IN);
	$content =~ s/ //g;
	if(open(OUT,"> $ARGV[1]")) {
		binmode(OUT);
		print OUT pack("H*",$content);
		close(OUT);
	}
	$bytes=int(length($content)/2);
	if($bytes>510) {
		warn "warning: out of memory for loader ($bytes bytes)\n";
	} else {
		warn "$bytes bytes written.\n";
	}
}
unlink "asbltemp.o";
